/* centering3x3.h
 */
#ifndef _CENTERING3X3_H
#define _CENTERING3X3_H

#include "osl/position.h"
#include "osl/misc/carray.h"

namespace osl
{
  /**
   * 3x3׾ˤޤ褦濴Ĵ
   */
  struct Centering3x3
  {
    struct Table 
    {
      CArray<Position,Position::SIZE> centers;
      Table();
    };
    static const Position adjustCenterNaive(Position);
    static const Table table;
    static const Position adjustCenter(Position src)
    {
      return table.centers[src.index()];
    }
  };

} // namespace osl

#endif /* _CENTERING3X3_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
