/* checkMoveGenerator.h
 */
#ifndef _CHECKMOVEGENERATOR_H
#define _CHECKMOVEGENERATOR_H

#include "osl/state/numEffectState.h"
#include <cstddef>

/**
 * @def DELAY_INTERPOSE
 * ɬפˤʤޤ礤θʤ.
 * (CheckmateSearcher  CheckMoveGenerator ξζĴɬ)
 */
#define DELAY_INTERPOSE
/** 
 * @def PAWN_CHECKMATE_SENSITIVE
 * ̤ͤԵ̤ͤȤ.
 * ʤ PawnCheckmate ֤٤Ȥ NoCheckmate 뤳Ȥ
 * ȡͤˤʤޤǡ⤬ʤɤޤʤŬԤ
 * (CheckmateSearcher  CheckMoveGenerator ξζĴɬ)
 */
#define PAWN_CHECKMATE_SENSITIVE

// /**
//  * @def DELAY_SACRIFICE
//  * ζ.
//  * Ĵɬ
//  */
// #define DELAY_SACRIFICE

namespace osl
{
  namespace checkmate
  {
    class CheckMoveList;
    /** 
     * CheckmateSearcher  OracleProver Ƕ̤˻Ȥ move generator
     * @param P ¦
     */
    template <Player P>
    struct CheckMoveGenerator
    {
      /** 
       * ɸ¦ move  out ˽񤭽Ф 
       * @return ο
       */
      static void generateEscape(const NumEffectState& state, 
				 CheckMoveList& out, 
				 Move last_move=Move::INVALID());
      
      /** 
       * ¦ move  out ˽񤭽Ф.
       * last_move ʤȡ꤬äƤǰǤʤ뤳Ȥ
       * @return ο
       */
      static void generateAttack(const NumEffectState& state, 
				 CheckMoveList& out,
				 Move last_move=Move::INVALID());
    
    };
  } // namespace checkmate
} // namespace osl

#endif /* _CHECKMOVEGENERATOR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
