#ifndef _SIMPLE_NO_PROMOTE_MOVE_ACTION_H
#define _SIMPLE_NO_PROMOTE_MOVE_ACTION_H

#include "osl/move_action/concept.h"
namespace osl
{
  namespace effect_action
  {
    /**
     * ʤȤ
     */
    template<class Action>
    class SimpleNoPromote
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    private:
      Action & ac;
    public:
      SimpleNoPromote(Action & a) :ac(a){}
      template<Player P,Ptype Type>
      void doActionPtype(Piece p1,Position to){
	if(!p1.isPromoted())
	  ac.simpleMove(p1.position(),to,Type,false,P);
      }
      template<Player P>
      void doAction(Piece p1,Position to){
	if(!p1.isPromoted())
	  ac.simpleMove(p1.position(),to,p1.ptype(),false,P);
      }
      bool done() const{ return false;}
    };
  } // namespace effect_action
    
} // namespace osl
#endif // _SIMPLE_NO_PROMOTE_MOVE_ACTION_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
