/* shouldPromoteCut.h
 */
#ifndef _SEARCH_SHOULDPROMOTECUT_H
#define _SEARCH_SHOULDPROMOTECUT_H

#include "osl/ptypeTable.h"
#include "osl/player.h"
#include "osl/move.h"
namespace osl
{
  namespace search
  {
    /**
     * õ޴ɤŪ˽񤤤Ƥ
     *
     * ̤İʳ cut Τ better 
       * TODO: ȡ2ܤؤιɬå򤤤
     */
    struct ShouldPromoteCut
    {
      template <Player P>
      static bool canIgnore(Ptype ptype, Position from, Position to)
      {
	assert(! from.isPieceStand());
	return isBasic(ptype)
	  && Ptype_Table.isBetterToPromote(ptype)
	  && (to.canPromote<P>() || from.canPromote<P>());
      }
      /**
       * dropǤʤȤꤷƤ
       */
      template <Player Moving>
      static bool canIgnoreMove(Move move)
      {
	assert(! move.isDrop());
	return canIgnore<Moving>(move.ptype(), move.from(), move.to());
      }
      /**
       * drop ̤åͭ
       */
      template <Player Moving>
      static bool canIgnoreAndNotDrop(Move move)
      {
	return (! move.isDrop()) && canIgnoreMove<Moving>(move);
      }
      static bool canIgnoreAndNotDrop(Move move)
      {
	if (move.player() == BLACK)
	  return canIgnoreAndNotDrop<BLACK>(move);
	else
	  return canIgnoreAndNotDrop<WHITE>(move);
      }
    };
    

  } // namespace search
} // osl

#endif /* _SHOULDPROMOTECUT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
