/* immediateCheckmate.cc
 */

#include "osl/checkmate/immediateCheckmate.tcc"

using namespace osl;
using namespace osl::checkmate;

#ifdef NEED_EXTRA_TEMPLATE_INSTANTIATION
template 
bool osl::checkmate::ImmediateCheckmate::
hasCheckmateMove<BLACK>(NumEffectState const&);

template 
bool osl::checkmate::ImmediateCheckmate::
hasCheckmateMove<WHITE>(NumEffectState const&);
#endif
bool osl::checkmate::ImmediateCheckmate::
hasCheckmateMove(Player pl,NumEffectState const& state)
{
  if(pl==BLACK)
    return hasCheckmateMove<BLACK>(state);
  else
    return hasCheckmateMove<WHITE>(state);

}
bool osl::checkmate::ImmediateCheckmate::
hasCheckmateMove(Player pl,NumEffectState const& state,Move& bestMove)
{
  if(pl==BLACK)
    return hasCheckmateMove<BLACK>(state,bestMove);
  else
    return hasCheckmateMove<WHITE>(state,bestMove);
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:

