/* pieceCost.cc
 */
#include "osl/checkmate/pieceCost.h"

namespace osl
{
  const CArray<signed char, PTYPE_SIZE> checkmate::
  PieceCost::attack_sacrifice_cost = 
  { 
    0, 0,			// empty, edge
    2, 4, 4, 4,		// ppawn - psilver
    8, 8,			// pbishop, prook
    0, 8, 			// king, gold
    1, 4, 4, 4,
    6, 6,
  };
  const CArray<signed char, PTYPE_SIZE> checkmate::
  PieceCost::defense_capture_cost = 
  { 
    0, 0,			// empty, edge
    0, -2, -2, -2,		// ppawn - psilver
    -3, -3,			// pbishop, prook
    0, -2, 			// king, gold
    0, -1, -1, -2,
    -2, -2,
  };
} // namespace osl

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
