/* twinList.cc
 */
#include "osl/checkmate/twinList.h"
#include <iostream>

void osl::checkmate::
TwinList::clear()
{
  slist<TwinEntry>::clear();
  size_cache = 0;
}

void osl::checkmate::
TwinList::dump(std::ostream& os) const
{
  os << "twin list " << size();
  for (const_iterator p=begin(); p!=end(); ++p)
  {
    os << " " << p->path;
  }
  os << "\n";
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
