/* hashKeyStack.cc
 */
#include "osl/hash/hashKeyStack.h"

osl::hash::
HashKeyStack::HashKeyStack(size_t capacity)
{
  data.reserve(capacity);
}

osl::hash::
HashKeyStack::~HashKeyStack()
{
}

void osl::hash::
HashKeyStack::push(const HashKey& key)
{
  data.push_back(key);
}

bool osl::hash::operator==(const HashKeyStack& l, const HashKeyStack& r)
{
  return l.data == r.data;
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
