/* bigramKillerMove.cc
 */
#include "osl/search/bigramKillerMove.h"
#include <iostream>

osl::search::
BigramKillerMove::BigramKillerMove()
{
  clear();
}

osl::search::
BigramKillerMove::~BigramKillerMove()
{
}

void osl::search::
BigramKillerMove::clear()
{
  killer_moves.fill(Move::INVALID());
}

void osl::search::
BigramKillerMove::dump() const
{
  for (int y=1; y<=9; ++y)
  {
    for (int x=1; x<=9; ++x)
    {
      const Position position(x,y);
      for (int p=PTYPEO_MIN; p<=PTYPEO_MAX; ++p)
      {
	const PtypeO ptypeo = static_cast<PtypeO>(p);
	const Move move = killer_moves[position.index()][ptypeOIndex(ptypeo)];
	if (move.isNormal())
	{
	  std::cerr << position << " " << move << "\n";
	}
      }
    }
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
