/* nullWindowSearch.cc
 */
#include "osl/search/nullWindowSearch.h"
#include "osl/search/nullWindowSearch.tcc"
#include "osl/search/searchFramework.tcc"
#include "osl/eval/progressEval.h"
#ifdef USE_EACH_PLAYER_PROGRESS_PLAYER
#  include "osl/eval/eachPlayerAttackDefense.h"
#endif
#include "osl/eval/pieceEval.h"
#include "osl/category/standardMoveGenerator.h"

namespace osl
{
  namespace search
  {
    template class NullWindowSearch<PieceEval,StandardMoveGenerator,
			SimpleHashTable,CountRecorder,RealizationProbability>;
    template class NullWindowSearch<eval::ProgressEval,StandardMoveGenerator,
			SimpleHashTable,CountRecorder,RealizationProbability>;
#ifdef USE_EACH_PLAYER_PROGRESS_PLAYER
    template class NullWindowSearch<eval::EachPlayerAttackDefense,StandardMoveGenerator,
			SimpleHashTable,CountRecorder,RealizationProbability>;
#endif
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
