#!/usr/bin/perl -w
use strict;

my $total = 20;

$total = $ARGV[0]
    if ($#ARGV >= 0);
my $p = 0.5;
#my $chi2_threshold = 6.63490; # for 1%
my $chi2_threshold = 3.84146; # for 5%
#my $chi2_threshold = 2.70554; # for 10%

for (my $i=$total;  $i>=($total*$p); --$i) {
    if (! &is_significant($i, $p, $total)) {
	printf("%d / %d\n", $i+1, $total);
	last;
    }
}

sub is_significant($$$) {
    my ($win, $p, $total) = @_;
    my $expected_win = $total*$p;
    my $expected_lose = $total - $expected_win;
    my $lose = $total - $win;
    my $chi = 1.0*($expected_win - $win)*($expected_win - $win)/$expected_win
	+ 1.0*($expected_lose - $lose)*($expected_lose - $lose)/$expected_lose;
    return $chi > $chi2_threshold;
}
