/* attackDefenceAroundKing.h
 */
#ifndef _ATTACK_DEFENCE_AROUND_KING_CAT_H
#define _ATTACK_DEFENCE_AROUND_KING_CAT_H

#include "osl/direction.h"
#include "osl/effect_util/neighboring25Direct.h"
#include "osl/category/categoryTraits.h"
#include "osl/category/categoryEnv.h"
#include "osl/category/standardMoveGenerator.h"

namespace osl
{
  namespace category
  {
    /**
     * ̤μ 5x5 ΰĤ
     * - P  move  player Ȱ̤ˤϰפʤΤ
     * - TODO 5x5 ΰǤζΰưޤ᤿ɤ
     * -- Open Moves?
     * -- 
     * -- (ͽ)礤ΰ֤֤Ƥ
     */
    template <Player P>
    struct AttackDefenceAroundKing : public FixedProbabilityCategory
    {
      static const FixedValueTable probTable; // 500;
      /**
       *  P μ 5x5 ΰǤιɤ˴ؤ
       * - ߤĤΤ
       */
      static const char *getName() { return "AttackDefenceAroundKing"; }
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	const PtypeO ptypeO = move.ptypeO ();
	Position from = move.to();
	Position king = env.state->template getKingPosition <P> ();
	
	return Neighboring25Direct::hasEffect(*env.state, ptypeO, from, king);
      }
    };
    
  }// namespace category
}// namespace osl
#endif /* _ATTACKDEFENCEAROUNDKING_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
