/* categoryConcept.h
 */
#ifndef _CATEGORYCONCEPT_H
#define _CATEGORYCONCEPT_H
#include <boost/concept_check.hpp>

namespace osl
{
  namespace category
  {
    /**
     * Category 
     */
    template <class T>
    struct CategoryConcept
    {
      void constraints() 
      {
	const char *name = T::getName();
	boost::ignore_unused_variable_warning(name);
	const int type = T::probType;
	boost::ignore_unused_variable_warning(type);
#if 0
	// ɤä¸ߤå뤫񤷤
	void (T::*generate)(const MockState&, int, MoveLogProbVector&)
	  = &T::generate;
#endif
      }
      // constraints ǻȤѿ constraints() γ뽬Ǥ
      //  default constructor ¸ߤ뤳Ȥˤʤ뤿ᡣ
      // MockState mockState;
    };
  }
} // namespace osl


#endif /* _CATEGORYCONCEPT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
