/* csaClient.h
 */
#ifndef GAME_PLAYING_CSACLIENT_H
#define GAME_PLAYING_CSACLIENT_H
#include "osl/game_playing/cuiClient.h"

namespace osl
{
  namespace game_playing
  {
    class CsaClient : public CuiClient
    {
    public:
      CsaClient(ComputerPlayer *black, ComputerPlayer *white,
		CsaLogger *l,
		std::istream&, std::ostream&);
      ~CsaClient();
      const Move computeMove(int& consumed);
    private:
      void readAndProcessCommand();
      void processComputerMove(Move, int seconds);
    };
  } // namespace game_playing
} // namespace osl


#endif /* _CSACLIENT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
