/* killerMoveTable.h
 */
#ifndef _KILLERMOVETABLE_H
#define _KILLERMOVETABLE_H

#include "osl/move.h"
#include "osl/misc/carray.h"
#include <cstddef>
#include <cassert>
namespace osl
{
  namespace search
  {
    /**
     * ñkiller move
     *
     * ȤκϿ롥ơ֥ϿƤʤ̤ǡ
     * ּʬؤ꤫餳ؤȺפȸȤͭ
     * ȽϤøǡοǺǸbestMoveȤȯ줿move
     *
     * (killer move)ݻƤߤ?
     */
    class KillerMoveTable
    {
    public:
      static const int KillerMoveMax = 64;
    private:
      CArray<Move,KillerMoveMax> killer_moves;
    public:
      KillerMoveTable();
      ~KillerMoveTable();
      void clear();
      void setMove(size_t depth, const Move& move)
      {
	assert(move.isValid());
	killer_moves[depth] = move;
      }
      const Move operator[](size_t depth) const
      {
	return killer_moves[depth];
      }
    };
  } // namespace search
} // namespace osl

#endif /* _KILLERMOVETABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
