/* searchEvalBase.h
 */
#ifndef _SEARCHEVALBASE_H
#define _SEARCHEVALBASE_H

#include "osl/search/fixedEval.h"

namespace osl
{
  namespace search
  {
    template <class EvalT>
    struct SearchEvalBase : public FixedEval
    {
      typedef EvalT eval_t;

    protected:
      SearchEvalBase() {
	assert(winThreshold(BLACK) > eval_t::infty());
      }
      ~SearchEvalBase() {}
    };
  } // namespace search
} // namespace osl

#endif /* _SEARCHEVALBASE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
