#ifndef SEARCHMOVE_VECTOR_H
#define SEARCHMOVE_VECTOR_H

#include "osl/move.h"
#include "osl/misc/fixedCapacityVector.h"
#include <iosfwd>

namespace osl
{
  namespace search
  {
    class SearchMove;
    typedef FixedCapacityVector<const SearchMove*,Move::MaxUniqMoves> 
    SearchMoveVectorBase;

    class SearchMoveVector : public SearchMoveVectorBase
    {
      typedef SearchMoveVectorBase base_t;
    public:
      void push_back(const SearchMove* move) {
	base_t::push_back(move);
      }
      /**
       * ɤsort 
       * @param default ϿƤʤ
       */
      template <Player P>
      void sortByValue(int default_value);
      /** Ψ⤤sort */
      void sortByProbability();
      /** Ψ㤤sort */
      void sortByProbabilityReverse();
    };
    std::ostream& operator<<(std::ostream& os,const SearchMoveVector& mv);

  } // namespace search
} // namespace osl
#endif // SEARCHMOVE_VECTOR_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
