/* attackDefenceAroundKing
 */

#include "osl/category/attackDefenceAroundKing.h"
#include "osl/search/realizationProbability.h"
#include "osl/move_generator/escape.h"
#include "osl/move_generator/allMoves.h"
#include "osl/move_action/store.h"
#include "osl/container/moveVector.h"

namespace osl
{
  namespace category
  {
    template <Player P>
    const FixedValueTable 
    AttackDefenceAroundKing<P>::probTable(search::FullWidthMoveProbability::DefaultProb);

    template <>
    const FixedValueTable 
    AttackDefenceAroundKing<BLACK>::probTable(search::FullWidthMoveProbability::DefaultProb);

    template <>
    const FixedValueTable 
    AttackDefenceAroundKing<WHITE>::probTable(search::FullWidthMoveProbability::DefaultProb);
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
