/* timeControl.cc
 */
#include "osl/search/timeControl.h"

int osl::search::TimeControl::
secondsForThisMove(int totalSeconds)
{
  if (totalSeconds < 90)
    return 1;
  if (totalSeconds < 2*60)
    return 4;
  if (totalSeconds < 3*60)
    return 8;
  if (totalSeconds < 4*60)
    return 10;
  if (totalSeconds < 6*60)
    return 15;
  if (totalSeconds < 8*60)
    return 20;
  if (totalSeconds < 10*60)
    return 25;
  if (totalSeconds < 12*60)
    return 30;
  if (totalSeconds < 25*60)
    return 45;
  if (totalSeconds < 60*60)	// 1h
    return 90;
  if (totalSeconds < 2*60*60)	// 2h
    return 180;
  return 400;
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
